IntraFont.init()
IntraFont.load("flash0:/font/ltn8.pgf", 1)

System.homePopup(0)

local oldpad = Controls.read()

math.randomseed(os.time())

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

local intro = Image.load("Images/intro.png")
local fond = Image.load("Images/fond.png")
local selecteurIMG = Image.load("Images/selecteur.png")
local zic = Image.load("Images/fond_zic.png")
local boule = Image.load("Images/boule.png")
local bouton = Image.load("Images/bouton.png")
local bouton2 = Image.load("Images/bouton2.png")
local selecteurM = Image.load("Images/selecteur2.png")

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

local blanc = Color.new(255, 255, 255)
local bleu = Color.new(0, 0, 255)
local bleuC = Color.new(5, 150, 245)
local noir = Color.new(0, 0, 0)
local gris = Color.new(159, 159, 159)
---
local blancI = IntraFont.color(255, 255, 255, 255)
local noirI = IntraFont.color(0, 0, 0, 255)
local noirI2 = IntraFont.color(0, 0, 0, 120)
local rougeI = IntraFont.color(255, 0, 0, 255)
local gris2I = IntraFont.color(180, 180, 180, 255)

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

local dossier = "ms0:/MUSIC"
System.currentDirectory(dossier)
local fichier = System.listDirectory()

local statut = "install"
local statut_prec = ""

local LuaMp3 = { }

local selecteur = { }
selecteur[1] = { s = 1, posX = 10 }
selecteur[2] = { s = 2, posX = 200 }
selecteur[3] = { s = 1, posY = 90 }

local y = 90
local partie = 1
local saut = 4
local stat_mp3 = 1
local alea = 0

local partie_option = 1
local luminosite = 92

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

config = { }
dofile("ms0:/PSP/GAME/LuaMP3/config.cfg")

function LuaMp3.saveConfig()
	local file = io.open("ms0:/PSP/GAME/LuaMP3/config.cfg", "w")
	for var, value in pairs(config) do
		file:write("config."..var.." = "..tostring(value).."\n")
	end
	file:close()
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function LuaMp3.heure(posY, couleur)
	local heures = System.getTime(1)
	local min = System.getTime(2)
	
	if System.getTime(5) == "pm" then
		heures = heures +12
	end
	Gu.start3d()
		if System.getTime(2) < 10 then
			IntraFont.print(480/2-string.len(heures..":".."0"..min)*10/2, posY, heures..":".."0"..min, 1, couleur, 0)
		else
			IntraFont.print(480/2-string.len(heures..":"..min)*10/2, posY, heures..":"..min, 1, couleur, 0)
		end
	Gu.end3d()
end

function LuaMp3.pourcent(x, y, x0, y0, couleur, couleur2)
	screen:fillRect(x, y, x0, y0, couleur)
	screen:fillRect(x, y, Mp3me.percent()*2, y0, couleur2)
	screen:blit(480/2-boule:width()/2-97+Mp3me.percent()*2, y-3.5, boule)
end

function LuaMp3.volume(x, y, x0, y0, couleur, couleur2)
	screen:fillRect(x, y, x0, y0, couleur)
	screen:fillRect(x, y, System.getVolume()*8, y0, couleur2)
	screen:blit(480/2-boule:width()/2-121+System.getVolume()*8, y-3.5, boule)
end

function LuaMp3.dir(posY)
	Gu.start3d()
		if System.currentDirectory() == "ms0:" then
			IntraFont.print(480/2-string.len("ms0:/")*8/2, posY, "ms0:/", 1, blancI, 0)
		else
			IntraFont.print(480/2-string.len(System.currentDirectory())*5/2, posY, string.sub(System.currentDirectory(), 6), 1, blancI, 0)
		end
	Gu.end3d()
end

function LuaMp3.info(posY)
	screen:print(10, posY, "X : Entrer", blanc)
	screen:print(480-string.len("L+R : Options")*8-10, posY, "L+R : Options", blanc)
end

function LuaMp3.next(mode)
	if mode == "suivant" then
		if selecteur[1].s < (#fichier + 1) then
			i = selecteur[1].s + 1
			if i < (#fichier + 1) then
				if string.upper(string.sub(fichier[i].name, -3)) == "MP3" then
					selecteur[1].s = selecteur[1].s +1
					Mp3me.stop()
					Mp3me.load(fichier[selecteur[1].s].name)
					Mp3me.play()
				end
			end
		end
	elseif mode == "precedent" then
		if selecteur[1].s < (#fichier + 1) and selecteur[1].s > 2 then
			i = selecteur[1].s - 1
			if i < (#fichier + 1) and i > 2 then
				if string.upper(string.sub(fichier[i].name, -3)) == "MP3" then
					Mp3me.stop()
					selecteur[1].s = selecteur[1].s -1
					Mp3me.load(fichier[selecteur[1].s].name)
					Mp3me.play()
				end
			end
		end
	end
end

function LuaMp3.accent(texte)
	local accent = { {'','e'}, {'','e'}, {'','a'}, {'','c'}, {'','e'}, {'','i'} }
	for i, k in ipairs(accent) do 
		texte = texte:gsub(k[1], k[2])
	end
	
	return texte
end

function LuaMp3.aleatoire()
	local alea = math.random(1+2, #fichier)
	if config.aleatoire == true then
		if Mp3me.gettime() == Mp3me.songTime() then	
			Mp3me.stop()
			Mp3me.load(fichier[alea].name)
			Mp3me.play()
		end
	end
end

function LuaMp3.repetition()
	if config.repetition == true then
		if Mp3me.gettime() == Mp3me.songTime() then
			Mp3me.stop()
			Mp3me.load(fichier[selecteur[1].s].name)
			Mp3me.play()
		end
	elseif config.repetition == false then
		if Mp3me.gettime() == Mp3me.songTime() then
			LuaMp3.next("suivant")
		end
	end
end

function LuaMp3.srollingBarre(x, y, couleur)
	local couleur = Color.new(0, 0, 0, 100)
	local h = 180
	local scroll = h / (#fichier - 1)
	local barre = Image.createEmpty(2, h)
	barre:clear(couleur)
	
	if #fichier > 5 then
		screen:blit(x, y + (selecteur[1].s - 1) * h / #fichier, barre, 0, 0, 2, scroll)
	elseif #fichier < 5 then
		scroll = 127 / (#fichier - 1)
		screen:blit(x, y + (selecteur[1].s - 1) * h / #fichier, barre, 0, 0, 2, scroll)
	elseif #fichier <= 2 then
		scroll = 180 / (#fichier - 1)
		screen:blit(x, y + (selecteur[1].s - 10) * h / #fichier, barre, 0, 0, 2, scroll)
	end
end

function LuaMp3.explo()
	LuaMp3.heure(14, noirI)
	LuaMp3.dir(46)
	LuaMp3.info(259)
	
	screen:print(480-string.len(System.powerGetBatteryLifePercent().."%")*8-10, 6, System.powerGetBatteryLifePercent().."%", noir)
	
	for i = partie, partie + saut - 1 do
		Gu.start3d()
			if string.len(fichier[i].name) >= 60 then
				IntraFont.print(10, y, string.sub(fichier[i].name, 1, 60).."...", 1, noirI, 0)
			elseif string.len(fichier[i].name) <= 60 then
				IntraFont.print(10, y, fichier[i].name, 1, noirI, 0)
			end
		Gu.end3d()

		y = y +48

		if #fichier == i then break end
	end

	y = 90
	
	screen:blit(0, (selecteur[1].s-partie)*47+64, selecteurIMG)
	
	Gu.start3d()
		if string.len(fichier[selecteur[1].s].name) >= 60 then
			IntraFont.print(selecteur[1].posX, (selecteur[1].s-partie)*48+90, fichier[selecteur[1].s].name, 1, blancI, 0)
			selecteur[1].posX = selecteur[1].posX - 1
			if selecteur[1].posX <= 0 - string.len(fichier[selecteur[1].s].name)*7.5 then
				selecteur[1].posX = 480
			end
		elseif string.len(fichier[selecteur[1].s].name) <= 60 then
			IntraFont.print(10, (selecteur[1].s-partie)*48+90, fichier[selecteur[1].s].name, 1, blancI, 0)
		end
	Gu.end3d()
	
	LuaMp3.srollingBarre(475, 66, noir)

	if pad:up() and not oldpad:up() and lecture ~= true then selecteur[1].s = selecteur[1].s -1 selecteur[1].posX = 10 end
	if pad:down() and not oldpad:down() and lecture ~= true then selecteur[1].s = selecteur[1].s +1 selecteur[1].posX = 10 end
	
	if config.joystick == true then
		if pad:analogY() > 50 and lecture ~= true then System.sleep(100) selecteur[1].s = selecteur[1].s +1 end
		if pad:analogY() < -50 and lecture ~= true then System.sleep(100) selecteur[1].s = selecteur[1].s -1 end
	end

	if selecteur[1].s < 1 then selecteur[1].s = 1 elseif selecteur[1].s > #fichier then selecteur[1].s = #fichier end
	if selecteur[1].s > partie + saut - 1 and partie + saut - 1 ~= #fichier then partie = partie + saut elseif selecteur[1].s < partie then partie = partie - saut 		end
	
	if pad:cross() and not oldpad:cross() and lecture ~= true then
		if fichier[selecteur[1].s].directory == true then
			System.currentDirectory(fichier[selecteur[1].s].name)
			fichier = System.listDirectory()
			table.getn(fichier)
			selecteur[1].s = 1
			partie = 1
		elseif fichier[selecteur[1].s].directory == false and lecture ~= true then
			if string.upper(string.sub(fichier[selecteur[1].s].name, -3)) == "MP3" then
				if System.powerGetBatteryLifePercent() <= 5 then
					if System.powerIsPowerOnline() then
						Mp3me.load(fichier[selecteur[1].s].name)
						Mp3me.play()
						lecture = true
					else
						System.message("Votre PSP n'a plus de batterie... ("..System.powerGetBatteryLifePercent().."%) \nLire la musique ?", 1)
					end
					if System.buttonPressed(0) == 1 then
						Mp3me.load(fichier[selecteur[1].s].name)
						Mp3me.play()
						lecture = true
					elseif System.buttonPressed(0) == 2 then
						statut = "lecteur"
						if System.powerIsPowerOnline() then
							-- rien
						else
							System.message("Pensez a recharger votre PSP !", 0)
						end
					end
				else
					Mp3me.load(fichier[selecteur[1].s].name)
					Mp3me.play()
					lecture = true
				end
			end
		end
	elseif pad:circle() and not oldpad:circle() and lecture ~= true then
		if fichier[selecteur[1].s].directory == false then
			System.removeFile(fichier[selecteur[1].s].name)
			System.message("Le fichier '"..fichier[selecteur[1].s].name.."' a ete supprime avec succes", 0)
			fichier = System.listDirectory()
			table.getn(fichier)
			selecteur[1].s = #fichier
			partie = 1
		end
	elseif pad:l() and pad:r() and lecture ~= true then
		statut_prec = "menu"
		statut = "options"
	elseif pad:hold() and not oldpad:hold() and lecture ~= true then
		local alea = math.random(1+2, #fichier)
		if aleatoire == "true" and string.upper(string.sub(fichier[alea].name, -3)) == "MP3" then
			Mp3me.load(fichier[alea].name)
			Mp3me.play()
			lecture = true
		else
			if System.currentDirectory() == "ms0:/MUSIC" then
				System.message("Lecture aleatoire desactivee, veuillez l'activer pour que l'hombrew choisisse une musique aleatoire", 0)
			end
		end
	end

	if lecture == true then
		screen:clear()
		screen:blit(0, 0, zic)
		
		LuaMp3.aleatoire()
		LuaMp3.repetition()
		
		LuaMp3.heure(14, gris2I)
		LuaMp3.pourcent(480/2-200/2, 83, 200, 4, blanc, bleuC)
		LuaMp3.volume(480/2-240/2, 260, 240, 5, blanc, bleuC)
		
		screen:print(480-string.len(System.powerGetBatteryLifePercent().."%")*8-10, 6, System.powerGetBatteryLifePercent().."%", gris)
		
		screen:blit(selecteur[2].posX, 196, selecteurM)
		
		if selecteur[2].s == 1 then selecteur[2].posX = 140 end
		if selecteur[2].s == 2 then selecteur[2].posX = 200 end
		if selecteur[2].s == 3 then selecteur[2].posX = 258 end
		
		screen:blit(480/2-bouton:width()/2, 227, bouton)
		
		if pad:cross() and not oldpad:cross() and lecture ~= false and selecteur[2].s == 1 then
			LuaMp3.next("precedent")
		elseif pad:cross() and not oldpad:cross() and lecture ~= false and selecteur[2].s == 2 then
			Mp3me.pause()
		elseif pad:cross() and not oldpad:cross() and lecture ~= false and selecteur[2].s == 3 then
			LuaMp3.next("suivant")
		end
		
		screen:print(480/2-string.len(Mp3me.artist())*8/2, 25, LuaMp3.accent(Mp3me.artist()), gris)
		screen:print(480/2-string.len(Mp3me.title())*8/2, 37, LuaMp3.accent(Mp3me.title()), blanc)
		screen:print(480/2-string.len(Mp3me.album())*8/2, 50, LuaMp3.accent(Mp3me.album()), gris)
		
		if System.currentDirectory() == "ms0:/MUSIC" or System.currentDirectory() == "ms0:/PSP/MUSIC" then
			screen:print(480/2-string.len(selecteur[1].s.." sur "..#fichier)*8/2, 70, selecteur[1].s-2 .." sur "..#fichier-2, blanc)
		end
		
		Gu.start3d()
			IntraFont.print(70, 90, string.sub(Mp3me.gettime(), 4), 1, blancI, 0)
			IntraFont.print(370, 90, string.sub(Mp3me.songTime(), 4), 1, blancI, 0)
		Gu.end3d()
		
		if pad:start() and not oldpad:start() and lecture ~= false then
			lecture = false
			Mp3me.stop()
		elseif pad:right() and not oldpad:right() and lecture ~= false then
			selecteur[2].s = selecteur[2].s +1
		elseif pad:left() and not oldpad:left() and lecture ~= false then
			selecteur[2].s = selecteur[2].s -1
		elseif pad:l() and pad:r() and lecture ~= false then
			statut_prec = "lecture"
			statut = "options"
		elseif pad:square() and not oldpad:square() then
			System.setVolume(0)
		end
		if pad:hold() == true then
			System.disableDisplay()
			System.setBrightness(0)
		else
			System.enableDisplay()
			System.setBrightness(luminosite)
		end
		if selecteur[2].s > 3 then selecteur[2].s = 3 elseif selecteur[2].s < 1 then selecteur[2].s = 1 end
	end
end

----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

while true do
	screen:clear()
	pad = Controls.read()
	
	System.setBrightness(luminosite)
	
	if pad:select() and not oldpad:select() then System.Quit() end
	
	if statut == "install" then
		if System.doesDirExist("flash1:/LPHMDRIVER") == 1 then
			if config.demarrage == 0 then
				System.message("Les drivers sont bien installes \nO pour voir la liste des musiques !", 0)
				config.demarrage = 1
				LuaMp3.saveConfig()
			elseif config.demarrage == 1 then
				statut = "lecteur"
			end
		else
			System.message("Les drivers ne sont pas installes !\nVeuillez les installer pour que l'hombrew fonctionne correctement\nLes installer ?", 1)
			if System.buttonPressed(0) == 1 then
				System.createDirectory("flash1:/LPHMDRIVER")
				System.copyFile("ms0:/PSP/GAME/LuaMP3/LPHMDRIVER/hook.prx", "flash1:/LPHMDRIVER/hook.prx", 1)
				System.copyFile("ms0:/PSP/GAME/LuaMP3/LPHMDRIVER/rdriver.prx", "flash1:/LPHMDRIVER/rdriver.prx", 1)
				System.copyFile("ms0:/PSP/GAME/LuaMP3/LPHMDRIVER/syslib.prx", "flash1:/LPHMDRIVER/syslib.prx", 1)
				System.removeDirectory("ms0:/PSP/GAME/LuaMP3/LPHMDRIVER")
				System.message("Les drivers ont bien ete installes !", 0)
				statut = "lecteur"
			end
		end
	end
	
	if statut == "lecteur" then
		screen:blit(0, 0, fond)
		LuaMp3.explo()
	end
	
	if statut == "options" then
		screen:blit(0, 0, fond)
		LuaMp3.heure(14, noirI)
		
		screen:print(480-string.len(System.powerGetBatteryLifePercent().."%")*8-10, 6, System.powerGetBatteryLifePercent().."%", noir)
		
		Gu.start3d()
			IntraFont.print(20, selecteur[3].posY, ">", 1, blancI, noirI2)
			if partie_option == 1 then
				IntraFont.print(10, 267, "\\/", 1, blancI, 0)
				if config.repetition == true then
					IntraFont.print(50, 90, "Lecture rptitif : activ", 1, blancI, noirI2)
				else
					IntraFont.print(50, 90, "Lecture rptitif : dsactiv", 1, blancI, noirI2)
				end
				if config.aleatoire == true then
					IntraFont.print(50, 138, "Lecture alatoire : activ", 1, blancI, noirI2)
				else
					IntraFont.print(50, 138, "Lecture alatoire : dsactiv", 1, blancI, noirI2)
				end
				if config.joystick == true then
					IntraFont.print(50, 186, "Joystick : activ", 1, blancI, noirI2)
				else
					IntraFont.print(50, 186, "Joystick : dsactiv", 1, blancI, noirI2)
				end
				IntraFont.print(50, 234, "CPU : "..config.cpu, 1, blancI, noirI2)
			elseif partie_option == 2 then
				IntraFont.print(10, 267, "/\\", 1, blancI, 0)
				IntraFont.print(50, 90, "Luminosit : "..System.getBrightness(), 1, blancI, noirI2)
				IntraFont.print(50, 138, "Retour", 1, blancI, noirI2)
			end
		Gu.end3d()
		
		if pad:down() and not oldpad:down() then selecteur[3].s = selecteur[3].s +1 end
		if pad:up() and not oldpad:up() then selecteur[3].s = selecteur[3].s -1 end
		
		if selecteur[3].s > 4 then partie_option = 2 elseif selecteur[3].s < 1 then selecteur[3].s = 1 end
		if partie_option == 2 and selecteur[3].s > 6 then selecteur[3].s = 6 elseif selecteur[3].s < 5 then partie_option = 1 end
		
		if selecteur[3].s == 1 then selecteur[3].posY = 90 end
		if selecteur[3].s == 2 then selecteur[3].posY = 138 end
		if selecteur[3].s == 3 then selecteur[3].posY = 186 end
		if selecteur[3].s == 4 then selecteur[3].posY = 234 end
		if selecteur[3].s == 5 then selecteur[3].posY = 90 end
		if selecteur[3].s == 6 then selecteur[3].posY = 138 end
		
		if pad:cross() and not oldpad:cross() then
			if selecteur[3].s == 1 then
				if config.repetition == true then config.repetition = false elseif config.repetition == false then config.repetition = true end
			elseif selecteur[3].s == 2 then
				if config.aleatoire == true then config.aleatoire = false elseif config.aleatoire == false then config.aleatoire = true end
			elseif selecteur[3].s == 3 then
				if config.joystick == true then config.joystick = false elseif config.joystick == false then config.joystick = true end
			elseif selecteur[3].s == 4 then
				if config.cpu == 133 then System.setReg() config.cpu = 266 elseif config.cpu == 266 then System.setHigh() config.cpu = 333
				elseif config.cpu == 333 then System.setLow() config.cpu = 133 end
			elseif selecteur[3].s == 6 then
				if statut_prec == "menu" then statut = "lecteur" elseif statut_prec == "lecture" then statut = "lecteur" lecture = true end
			end
			LuaMp3.saveConfig()
		end
		if selecteur[3].s == 5 then
			if pad:right() then luminosite = luminosite +1 elseif pad:left() then luminosite = luminosite -1 end
			if luminosite >= 92 then luminosite = 92 elseif luminosite <= 10 then luminosite = 10 end
		end
	end
	
	screen.flip()
	screen.waitVblankStart()
	oldpad = pad
end